diff --git a/hw/net/vhost_net.c b/hw/net/vhost_net.c
index 30379d2..9a4479b 100644
--- a/hw/net/vhost_net.c
+++ b/hw/net/vhost_net.c
@@ -322,6 +322,7 @@ int vhost_net_start(VirtIODevice *dev, NetClientState *ncs,
     BusState *qbus = BUS(qdev_get_parent_bus(DEVICE(dev)));
     VirtioBusState *vbus = VIRTIO_BUS(qbus);
     VirtioBusClass *k = VIRTIO_BUS_GET_CLASS(vbus);
+    bool mq = virtio_host_has_feature(dev, VIRTIO_NET_F_MQ);
     int total_notifiers = data_queue_pairs * 2 + cvq;
     VirtIONet *n = VIRTIO_NET(dev);
     int nvhosts = data_queue_pairs + cvq;
@@ -343,7 +344,7 @@ int vhost_net_start(VirtIODevice *dev, NetClientState *ncs,
         if (i < data_queue_pairs) {
             peer = qemu_get_peer(ncs, i);
         } else { /* Control Virtqueue */
-            peer = qemu_get_peer(ncs, n->max_queue_pairs);
+            peer = qemu_get_peer(ncs, mq ? data_queue_pairs : n->max_queue_pairs);
         }
 
         net = get_vhost_net(peer);
@@ -368,7 +369,7 @@ int vhost_net_start(VirtIODevice *dev, NetClientState *ncs,
         if (i < data_queue_pairs) {
             peer = qemu_get_peer(ncs, i);
         } else {
-            peer = qemu_get_peer(ncs, n->max_queue_pairs);
+            peer = qemu_get_peer(ncs, mq ? data_queue_pairs : n->max_queue_pairs);
         }
         r = vhost_net_start_one(get_vhost_net(peer), dev);
 
@@ -390,7 +391,10 @@ int vhost_net_start(VirtIODevice *dev, NetClientState *ncs,
 
 err_start:
     while (--i >= 0) {
-        peer = qemu_get_peer(ncs , i);
+        if (mq)
+            peer = qemu_get_peer(ncs, i < data_queue_pairs ? i : data_queue_pairs);
+        else
+            peer = qemu_get_peer(ncs, i < data_queue_pairs ? i : n->max_queue_pairs);
         vhost_net_stop_one(get_vhost_net(peer), dev);
     }
     e = k->set_guest_notifiers(qbus->parent, total_notifiers, false);
@@ -409,6 +413,7 @@ void vhost_net_stop(VirtIODevice *dev, NetClientState *ncs,
     VirtioBusState *vbus = VIRTIO_BUS(qbus);
     VirtioBusClass *k = VIRTIO_BUS_GET_CLASS(vbus);
     VirtIONet *n = VIRTIO_NET(dev);
+    bool mq = virtio_host_has_feature(dev, VIRTIO_NET_F_MQ);
     NetClientState *peer;
     int total_notifiers = data_queue_pairs * 2 + cvq;
     int nvhosts = data_queue_pairs + cvq;
@@ -418,7 +423,7 @@ void vhost_net_stop(VirtIODevice *dev, NetClientState *ncs,
         if (i < data_queue_pairs) {
             peer = qemu_get_peer(ncs, i);
         } else {
-            peer = qemu_get_peer(ncs, n->max_queue_pairs);
+            peer = qemu_get_peer(ncs, mq ? data_queue_pairs : n->max_queue_pairs);
         }
         vhost_net_stop_one(get_vhost_net(peer), dev);
     }
diff --git a/hw/virtio/vhost-vdpa.c b/hw/virtio/vhost-vdpa.c
index 27ea706..623476e 100644
--- a/hw/virtio/vhost-vdpa.c
+++ b/hw/virtio/vhost-vdpa.c
@@ -1097,7 +1097,30 @@ static int vhost_vdpa_dev_start(struct vhost_dev *dev, bool started)
         vhost_vdpa_host_notifiers_uninit(dev, dev->nvqs);
     }
 
-    if (dev->vq_index + dev->nvqs != dev->vq_index_end) {
+    /* FIXME the vhost_dev group for the control vq may have bogus nvqs=2
+     * value rather than nvqs=1. This can happen in case the guest doesn't
+     * support multiqueue, as a result of virtio_net_change_num_queue_pairs()
+     * destroying and rebuilding all the vqs, the guest index for control vq
+     * will no longer align with the host's. Currently net_init_vhost_vdpa()
+     * only initializes all vhost_dev's and net_clients once during
+     * net_client_init1() time, way earlier before multiqueue feature
+     * negotiation can kick in.
+     *
+     * Discussion - some possible fixes so far I can think of:
+     *
+     * option 1: fix vhost_net->dev.nvqs and nc->is_datapath in place for
+     * vdpa's ctrl vq, or rebuild all vdpa's vhost_dev groups and the
+     * net_client array, in the virtio_net_set_multiqueue() path;
+     *
+     * option 2: fix vhost_dev->nvqs in place at vhost_vdpa_set_features()
+     * before coming down to vhost_vdpa_dev_start() (Q: nc->is_datapath
+     * seems only used in virtio_net_device_realize, is it relevant?);
+     *
+     * option 3: use host queue index all along in vhost-vdpa ioctls instead
+     * of using guest vq index, so that vhost_net_start/stop() can remain
+     * as-is today
+     */
+    if (dev->vq_index + dev->nvqs < dev->vq_index_end) {
         return 0;
     }
 